/**
 * 翻书插件
 */
$.fn.bookSlider = function(opt){
    opt = $.extend({
	   pageIndex : 1,
	   pageWidth : 0
	} , opt);
	
    $this = $(this);
	var pages = {};
	var lock = false;//锁定状态
	var animatime = 400; //动画时间
	
	this.run = function(){
	   this.showPageByIndex(opt.pageIndex , 0);
	   this.showPageByIndex(opt.pageIndex+1 , 0);
	   this.showPageByIndex(opt.pageIndex-1 , 1);
	   this.currpage = this.activeByIndex(opt.pageIndex);
	   this.bindEvent();
	};
	
	//事件绑定
	this.bindEvent = function(){
	    var _self = this , x = x_s = x_e = 0 , on = false;
		var t_s = t_e = 0;
		var mpage = null;//当前移动的对象
		var mtype = 0;//0 下一页 1上一页
		var m_x = 0;//记录移动的距离
		var _e = null;
        
		$(document).on('touchmove',function(e){
			e.preventDefault();
		});
		
		//向左滑动
		function _onMoveToLeft(enableTime){
		    if(!mpage || lock)return true;
		    var x_c = x_s - x_e , ok = false;
			if(x_c > opt.pageWidth * 0.2 || (enableTime && t_e - t_s < 300)){
				ok = true;
				x_c = opt.pageWidth - x_c;	
			}
			var rate = x_c / opt.pageWidth;
			lock = true;
			_self.movePageWidthAnimate(mpage , rate * animatime ,( ok ?  -opt.pageWidth : 0), function(){
				if(ok){
					opt.pageIndex++;
					_self.currpage = _self.activeByIndex(opt.pageIndex);
					_self.onPageChange(opt.pageIndex , mtype);
				}
				lock = false;
			});
		};
		
		//向右滑动
		function _onMoveToRight(enableTime){
		    if(!mpage || lock)return true;
		    var x_c = x_e - x_s , ok = false;
			if(x_c > opt.pageWidth * 0.2 || (enableTime && t_e - t_s < 300)){
				ok = true;
				x_c = opt.pageWidth - x_c;	
			}
			var rate = x_c / opt.pageWidth;
			lock = true;
			_self.movePageWidthAnimate(mpage , rate * animatime ,( ok ?  0 : -opt.pageWidth), function(){
				if(ok){
					opt.pageIndex--;
					_self.currpage =  _self.activeByIndex(opt.pageIndex);
					_self.onPageChange(opt.pageIndex , mtype);
				}else{
					_self.activeByIndex(opt.pageIndex);
				}
				lock = false;
			});
		};
		
		//重置位置
		function _resetpos(){
		    if(!mpage || lock)return true;
		    if(x_e != x_s && mpage){
			    lock = true;
			    _self.movePage(mpage , 0 , 0 , mtype , function(){
				    if(mtype){
					    _self.activeByIndex(opt.pageIndex);
				    }
					lock = false;
			    });
			}
		};
		
		//事件绑定
		$this.on(app.event.parseEvent('touchstart') , function(e){
			if(lock)return false;//锁定中
			x = x_s  = app.event.getE(e).clientX;
			t_s = e.timeStamp;
			on = true;
			mpage = null;
			mtype = 0;
			m_x = 0;
		}).on(app.event.parseEvent('touchmove'),function(e){
		    if(lock)return false;//锁定中
			_e = app.event.getE(e);
			m_x += Math.abs(_e.clientX - x_s);
			if(on){
			    x_e = _e.clientX;
				if(x_e != x_s){ 
					if(mpage == null || (mtype == 0 && x_e > x_s) || (mtype && x_e < x_s)){
						if(mpage && ((mtype == 0 && x_e > x_s) || (mtype && x_e < x_s))){ //复位当前选择
							_resetpos();
						}
						if(x_e < x_s){//向左
						    if(_self.isExistPage(opt.pageIndex+1) === false){
							    on = false;
								_self.onPageChange(opt.pageIndex , 0);
								return false;
							}
							mpage = _self.currpage;
							mtype = 0;
						}else{//向右
							mpage = _self.activeByIndex(opt.pageIndex - 1);
						    mtype = 1;
							if(mpage === false){
							    on = false;
								_self.onPageChange(opt.pageIndex , 1);
								return false;
							}
						}
					}
					_self.movePage(mpage , x_s , x_e , mtype);
				}
			}
		}).on(app.event.parseEvent('touchend') , function(e){
		    if(lock)return false;//锁定中
			t_e = e.timeStamp;
			if(on){
				if(Math.abs(x_e - x_s) < 30 && m_x >= 30){
				    _resetpos();
				}
				on = false;
			}
		}).on('swipeLeft' , function(e){
			_onMoveToLeft(true);
		}).on('swipeRight' , function(e){
			_onMoveToRight(true);
		}).on('swipeUp' , function(e){
			if(Math.abs(x_e - x) > 5){
			    if(mtype){
				   _onMoveToRight(false);
				}else{
				   _onMoveToLeft(false);
				}
			}else{
			    _resetpos();
			}
		}).on('swipeDown' , function(e){
			if(Math.abs(x_e - x) > 5){
			    if(mtype){
				   _onMoveToRight(false);
				}else{
				   _onMoveToLeft(false);
				}
			}else{
			    _resetpos();
			}
		});
		
		//点击页面
		$this.on(app.event.parseEvent('tap') , function(){
		    if(x >= 0.8* opt.pageWidth){ //下一页
			    if(lock)return false;//锁定中
			    if(_self.isExistPage(opt.pageIndex + 1)){
				    lock = true;
					var page = _self.getPageByIndex(opt.pageIndex);
					_self.movePageWidthAnimate(page , animatime , -opt.pageWidth , function(){
						opt.pageIndex++;
						_self.currpage = _self.activeByIndex(opt.pageIndex);
						_self.onPageChange(opt.pageIndex , 0);
					   lock = false;
					});
				}else{
				    _resetpos();//可能有移动
					//_self.onPageChange(opt.pageIndex , 0);
				}
			}else if(x <= 0.2 * opt.pageWidth){ //上一页
			    if(lock)return false;//锁定中
			    var page =  _self.isExistPage(opt.pageIndex - 1);
			    if(page){
				    _self.activePage(page);
					lock = true;
					setTimeout(function(){
						_self.movePageWidthAnimate(page , animatime , 0 , function(){
							 _self.currpage = page;
							 opt.pageIndex--;
							 _self.onPageChange(opt.pageIndex , 1);
							 lock = false;
						});
					} , 100);
				}else{
				    _resetpos();//可能有移动
					//_self.onPageChange(opt.pageIndex , 1);
				}
			}else{//可能有移动
			    _resetpos();
				opt.onClick();
			}
		});
	};
	
	//移动页面
	this.movePage = function(t , x_s , x_e , mtype , cb){
	    t.animate({
		  'translate3d' : ((mtype ?  -opt.pageWidth : 0)  + (x_e - x_s)) + 'px,0px,0px'
		}, 0 , '',function(){
		     cb && cb();
		});
	};
	
	//动画移动页面
	this.movePageWidthAnimate = function(t , time , offset , cb){
	    var animate = {
		    'translate' : offset + 'px,0px' , 
		    'transition-duration': time / 1000 + 's',
		};
		var afunction = '';
		if(time){
		   animate['transition-timing-function'] = 'cubic-bezier(0.25, 0.46, 0.45, 0.94)';
	       afunction = 'cubic-bezier(0.25, 0.46, 0.45, 0.94)';
		}
		t.animate(animate, time , afunction ,function(){
			cb && cb();
		});
	};
	
	//获取页对象
	this.getPageByIndex = function(index){
	    if(index > 0){
			if(typeof pages[index] == 'undefined'){
				var page = $this.find(".r-page.p_"+index+"");
				pages[index] = {
				     status : 0,//可移动状态
				     obj : page.length ? page : false
				}
			}
			return pages[index].obj;
		}else{
		    return false;
		}
	};
	
	this.activeByIndex = function(index){
	    var page = this.getPageByIndex(index);
		return this.activePage(page);
    };
	
	this.activePage = function(page){
	    if(page){
		    page.removeClass('hide').addClass('curr');
	        $this.find(".curr").removeClass('curr');
		}
		return page;
	};
	
	//页面切换事件
	this.onPageChange = function(index , mtype){
	    if(mtype){//向右
		    if(this.showPageByIndex(index - 1 , mtype)){
			    this.hidePageByIndex(index + 2);
			}
		}else{//向左
			if(this.showPageByIndex(index + 1 , mtype)){
			    this.hidePageByIndex(index - 2);
			}
		}
		opt.onPageChange(index);
	};
	
	//显示Page
	this.showPageByIndex = function(index , mtype , rload){
	    var page = this.getPageByIndex(index),_self=this;
		if(page == false){
		    if(index > 0 && index <= opt.pageTotal){
			    var prev_page = pages[(mtype ? (index + 1) : (index - 1))];
				if(!!rload || typeof prev_page == 'undefined' || prev_page.status == 1){
					pages[index] = {};
					page = opt.loadpage(index , mtype , function(pageIndex , status){//加载页面
						pages[pageIndex].status = status;
					});
					pages[index].obj = page;
				}
			}else{
			    if(index > opt.pageTotal){ //最后一页
					var prev_page = pages[index - 1];
					if(typeof prev_page != 'undefined' && prev_page && prev_page.status == 1){
						page = opt.onEndPage(index , mtype , function(pageIndex , status){
							 pages[pageIndex].status = status;
						});
						pages[index].obj = page;
					}
				}
			}
		}
		if(page){
		    page.removeClass('hide');
			if(mtype){
				_self.movePageWidthAnimate(page , 0 , -opt.pageWidth); //如果是加载之前的页面，则加载后需将其移动到隐藏位置
			}
		}
		return page;
	};
	
	//隐藏上一页
	this.hidePageByIndex = function(index){
	    var page = this.getPageByIndex(index);
		if(page){
		    page.addClass('hide');
			page.remove();
			delete pages[index];
		}
		return page;
	};

	this.isExistPage = function(index){
	    return this.getPageByIndex(index);
	};
	
	//重设选项
	this.resetopt = function(_opt){
	    opt = $.extend(opt , _opt);
	};
	
	//下一页
	this.next = function(){
	    var _self = this;
		if(_self.isExistPage(opt.pageIndex + 1)){
			lock = true;
			_self.movePageWidthAnimate(_self.currpage , animatime , -opt.pageWidth , function(){
				opt.pageIndex++;
				_self.currpage = _self.activeByIndex(opt.pageIndex);
				_self.onPageChange(opt.pageIndex , 0);
			   lock = false;
			});
		}
	};
	
	//清除其它页面
	this.clearOtherPage = function(){
	    //前一页
	    var pindex = opt.pageIndex - 1, page = this.getPageByIndex(pindex);
		if(page){
		    page.addClass('hide');
			page.remove();
			delete pages[pindex];
		}
		
		//后一页
		pindex = opt.pageIndex + 1;
		page = this.getPageByIndex(pindex);
		if(page){
		    page.addClass('hide');
			page.remove();
			delete pages[pindex];
		}
	};

	this.run();
	return this;
};